//+------------------------------------------------------------------+
//|                                              Corruption Test.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " "
#property link      " "

// Indicator Variables
#property indicator_chart_window

#property indicator_buffers 8

#property indicator_color1 Red
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
#property indicator_color3 Red
#property indicator_width3 2
#property indicator_color4 Red
#property indicator_width4 2
#property indicator_color5 Yellow
#property indicator_width5 2
#property indicator_color6 Yellow
#property indicator_width6 2
#property indicator_color7 Yellow
#property indicator_width7 2
#property indicator_color8 Yellow
#property indicator_width8 2

extern string EA_ID = "Test1"
;
double Down1[];
double Down2[];
double Down3[];
double Down4[];
double Up1[];
double Up2[];
double Up3[];
double Up4[];

datetime drawTime;
bool draw = true;
bool oddDown = true;
bool oddUp = true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   // Clean up any indicators / objects from the previous run of the indicator on the chart
   ObjectsDeleteAll(EMPTY, EMPTY);

   // Initialize the indicators
   SetIndexBuffer(0, Down1);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexEmptyValue(0, EMPTY_VALUE);

   SetIndexBuffer(1, Down2);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexEmptyValue(1, EMPTY_VALUE);
   
   SetIndexBuffer(2, Down3);
   SetIndexStyle(2, DRAW_HISTOGRAM, EMPTY, 1, Red);
   SetIndexEmptyValue(2, EMPTY_VALUE);

   SetIndexBuffer(3, Down4);
   SetIndexStyle(3, DRAW_HISTOGRAM, EMPTY, 1, Red);
   SetIndexEmptyValue(3, EMPTY_VALUE);
   
   SetIndexBuffer(4, Up1);
   SetIndexStyle(4, DRAW_LINE);
   SetIndexEmptyValue(4, EMPTY_VALUE);

   SetIndexBuffer(5, Up2);
   SetIndexStyle(5, DRAW_LINE);
   SetIndexEmptyValue(5, EMPTY_VALUE);
   
   SetIndexBuffer(6, Up3);
   SetIndexStyle(6, DRAW_HISTOGRAM, EMPTY, 1, Yellow);
   SetIndexEmptyValue(6, EMPTY_VALUE);

   SetIndexBuffer(7, Up4);
   SetIndexStyle(7, DRAW_HISTOGRAM, EMPTY, 1, Yellow);
   SetIndexEmptyValue(7, EMPTY_VALUE);
   
   drawTime = TimeCurrent() - 1501;
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   if (drawTime + 3000 < TimeCurrent()) {
      drawTime = TimeCurrent();
      if (oddUp) {
         DrawMoveEx("Up1", 20, 1, iLow(NULL, 0, 20), iHigh(NULL, 0, 1));
         oddUp = false;
      } else {
         DrawMoveEx("Up2", 20, 1, iLow(NULL, 0, 20), iHigh(NULL, 0, 1)); 
         oddUp = true;
      }
      
      draw = true;
      
      int fileHandle = FileOpen(StringConcatenate(EA_ID, "_", fileHandle, ".csv"), FILE_WRITE);
      for (int i = 0; i < Bars; i++)   
         FileWrite(fileHandle, StringConcatenate(i, ", ", Time[i], ", ", Up1[i], ", ", Down1[i]));
      FileClose(fileHandle);

   } else if ((drawTime + 1500 < TimeCurrent()) && (draw)) {
      if (oddDown) {
         DrawMoveEx("Down1", 20, 1, iHigh(NULL, 0, 20), iLow(NULL, 0, 1));
         oddDown = false;
      } else {
         DrawMoveEx("Down2", 20, 1, iHigh(NULL, 0, 20), iLow(NULL, 0, 1));
         oddDown = true;
      }
        
      draw = false;
   }

   return(0);
  }
//+------------------------------------------------------------------+

void DrawMoveEx(string arrayName, int start, int end, double startlevel, double endlevel) {
   double a = (startlevel - endlevel) / (start - end);

   for(int bar = start; bar >= end; bar--) {
      if (StringFind(arrayName, "Up1", 0) == 0)
         Up1[bar] = startlevel + a * (bar - start);
      else if (StringFind(arrayName, "Up2", 0) == 0)
         Up2[bar] = startlevel + a * (bar - start);        
      else if (StringFind(arrayName, "Down1", 0) == 0)
         Down1[bar] = startlevel + a * (bar - start);        
      else if (StringFind(arrayName, "Down2", 0) == 0)
         Down2[bar] = startlevel + a * (bar - start);    
   }
}